<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: scan_fhog_pyramid_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_6fa195adb58ca7edc2dded7e6bc48796.html">image_processing</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">scan_fhog_pyramid_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2013  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SCAN_fHOG_PYRAMID_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SCAN_fHOG_PYRAMID_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../image_transforms/fhog_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;object_detector_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keyword">typename</span> Pyramid_type,</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> feature_extractor_type</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        &gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    matrix&lt;unsigned char&gt; draw_fhog (</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keyword">const</span> object_detector&lt;scan_fhog_pyramid&lt;Pyramid_type,feature_extractor_type&gt; &gt;&amp; detector,</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> weight_index = 0,</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> cell_draw_size = 15</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    );</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">typename</span> Pyramid_type,</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">typename</span> feature_extractor_type</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        &gt;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_separable_filters (</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">const</span> object_detector&lt;scan_fhog_pyramid&lt;Pyramid_type,feature_extractor_type&gt; &gt;&amp; detector,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> weight_index = 0</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    );</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">typename</span> Pyramid_type,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">typename</span> feature_extractor_type</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        &gt;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    object_detector&lt;scan_fhog_pyramid&lt;Pyramid_type,feature_extractor_type&gt; &gt; threshold_filter_singular_values (</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">const</span> object_detector&lt;scan_fhog_pyramid&lt;Pyramid_type,feature_extractor_type&gt; &gt;&amp; detector,</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordtype">double</span> thresh,</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> weight_index = 0</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    );</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keyword">class </span>default_fhog_feature_extractor</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    {</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        rectangle image_to_feats (</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="keywordtype">int</span> cell_size,</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            <span class="keywordtype">int</span> filter_rows_padding,</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            <span class="keywordtype">int</span> filter_cols_padding</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> image_to_fhog(rect, cell_size, filter_rows_padding, filter_cols_padding); }</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        rectangle feats_to_image (</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            <span class="keywordtype">int</span> cell_size,</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <span class="keywordtype">int</span> filter_rows_padding,</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            <span class="keywordtype">int</span> filter_cols_padding</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fhog_to_image(rect, cell_size, filter_rows_padding, filter_cols_padding); }</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            &gt;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordtype">void</span> operator()(</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            <span class="keyword">const</span> image_type&amp; img, </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            <a class="code" href="classdlib_1_1array.html">dlib::array</a>&lt;array2d&lt;float&gt; &gt;&amp; hog, </div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keywordtype">int</span> cell_size,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keywordtype">int</span> filter_rows_padding,</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordtype">int</span> filter_cols_padding</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        )<span class="keyword"> const </span>{ extract_fhog_features(img,hog,cell_size,filter_rows_padding,filter_cols_padding); }</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_planes (</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 31; }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    };</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160; </div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> serialize   (<span class="keyword">const</span> default_fhog_feature_extractor&amp;, std::ostream&amp;) {}</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> deserialize (default_fhog_feature_extractor&amp;, std::istream&amp;) {}</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160; </div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <span class="keyword">typename</span> Pyramid_type,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keyword">typename</span> Feature_extractor_type = default_fhog_feature_extractor</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        &gt;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keyword">class </span>scan_fhog_pyramid : noncopyable</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    {</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keyword">typedef</span> matrix&lt;double,0,1&gt; feature_vector_type;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keyword">typedef</span> Pyramid_type pyramid_type;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keyword">typedef</span> Feature_extractor_type feature_extractor_type;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160; </div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        scan_fhog_pyramid (</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        );  </div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keyword">explicit</span> scan_fhog_pyramid (</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <span class="keyword">const</span> feature_extractor_type&amp; fe</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        );  </div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            &gt;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">void</span> load (</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keyword">const</span> image_type&amp; img</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        );</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        <span class="keyword">const</span> feature_extractor_type&amp; get_feature_extractor(</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keywordtype">bool</span> is_loaded_with_image (</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keywordtype">void</span> copy_configuration (</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            <span class="keyword">const</span> scan_fhog_pyramid&amp; item</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        );</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        <span class="keywordtype">void</span> set_detection_window_size (</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> window_width,</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> window_height</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        );</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_detection_window_width (</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_detection_window_height (</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_fhog_window_width (</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_fhog_window_height (</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        <span class="keywordtype">void</span> set_padding (</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> new_padding</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        );</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_padding (</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_cell_size (</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keywordtype">void</span> set_cell_size (</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> new_cell_size</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        );</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">long</span> get_num_dimensions (</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_detection_templates (</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_movable_components_per_detection_template (</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_max_pyramid_levels (</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <span class="keywordtype">void</span> set_max_pyramid_levels (</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_levels</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;        );</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        <span class="keywordtype">void</span> set_min_pyramid_layer_size (</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> width,</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> height </div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;        );</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_min_pyramid_layer_width (</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_min_pyramid_layer_height (</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;        fhog_filterbank build_fhog_filterbank (</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;            <span class="keyword">const</span> feature_vector_type&amp; weights </div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;        <span class="keyword">class </span>fhog_filterbank </div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        {</div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;            <span class="keywordtype">long</span> get_num_dimensions(</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;            <span class="keyword">const</span> std::vector&lt;matrix&lt;float&gt; &gt;&amp; get_filters(</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;            ) <span class="keyword">const</span>; </div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_separable_filters(</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;        };</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160; </div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;        <span class="keywordtype">void</span> detect (</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;            <span class="keyword">const</span> fhog_filterbank&amp; w,</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;            std::vector&lt;std::pair&lt;double, rectangle&gt; &gt;&amp; dets,</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> thresh</div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;        <span class="keywordtype">void</span> detect (</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;            <span class="keyword">const</span> feature_vector_type&amp; w,</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;            std::vector&lt;std::pair&lt;double, rectangle&gt; &gt;&amp; dets,</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> thresh</div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;        <span class="keywordtype">void</span> get_feature_vector (</div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;            <span class="keyword">const</span> full_object_detection&amp; obj,</div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;            feature_vector_type&amp; psi</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;        full_object_detection get_full_object_detection (</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;            <span class="keyword">const</span> feature_vector_type&amp; w</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00631"></a><span class="lineno">  631</span>&#160;        <span class="keyword">const</span> rectangle get_best_matching_rect (</div><div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00633"></a><span class="lineno">  633</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;        <span class="keywordtype">double</span> get_nuclear_norm_regularization_strength (</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        <span class="keywordtype">void</span> set_nuclear_norm_regularization_strength (</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;            <span class="keywordtype">double</span> strength</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;        );</div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;    };</div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160; </div><div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160; </div><div class="line"><a name="l00679"></a><span class="lineno">  679</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00680"></a><span class="lineno">  680</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;        <span class="keyword">const</span> scan_fhog_pyramid&lt;T&gt;&amp; item,</div><div class="line"><a name="l00682"></a><span class="lineno">  682</span>&#160;        std::ostream&amp; out</div><div class="line"><a name="l00683"></a><span class="lineno">  683</span>&#160;    );</div><div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160; </div><div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;        scan_fhog_pyramid&lt;T&gt;&amp; item,</div><div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;        std::istream&amp; in </div><div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;    );</div><div class="line"><a name="l00699"></a><span class="lineno">  699</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00700"></a><span class="lineno">  700</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00701"></a><span class="lineno">  701</span>&#160; </div><div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;        <span class="keyword">typename</span> pyramid_type,</div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;        <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;        &gt;</div><div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;    <span class="keywordtype">void</span> evaluate_detectors (</div><div class="line"><a name="l00707"></a><span class="lineno">  707</span>&#160;        <span class="keyword">const</span> std::vector&lt;object_detector&lt;scan_fhog_pyramid&lt;pyramid_type&gt;&gt;&gt;&amp; detectors,</div><div class="line"><a name="l00708"></a><span class="lineno">  708</span>&#160;        <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00709"></a><span class="lineno">  709</span>&#160;        std::vector&lt;rect_detection&gt;&amp; dets,</div><div class="line"><a name="l00710"></a><span class="lineno">  710</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> adjust_threshold = 0</div><div class="line"><a name="l00711"></a><span class="lineno">  711</span>&#160;    );</div><div class="line"><a name="l00753"></a><span class="lineno">  753</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00754"></a><span class="lineno">  754</span>&#160; </div><div class="line"><a name="l00755"></a><span class="lineno">  755</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00756"></a><span class="lineno">  756</span>&#160;        <span class="keyword">typename</span> pyramid_type,</div><div class="line"><a name="l00757"></a><span class="lineno">  757</span>&#160;        <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00758"></a><span class="lineno">  758</span>&#160;        &gt;</div><div class="line"><a name="l00759"></a><span class="lineno">  759</span>&#160;    std::vector&lt;rectangle&gt; evaluate_detectors (</div><div class="line"><a name="l00760"></a><span class="lineno">  760</span>&#160;        <span class="keyword">const</span> std::vector&lt;object_detector&lt;scan_fhog_pyramid&lt;pyramid_type&gt;&gt;&gt;&amp; detectors,</div><div class="line"><a name="l00761"></a><span class="lineno">  761</span>&#160;        <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00762"></a><span class="lineno">  762</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> adjust_threshold = 0</div><div class="line"><a name="l00763"></a><span class="lineno">  763</span>&#160;    );</div><div class="line"><a name="l00778"></a><span class="lineno">  778</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00779"></a><span class="lineno">  779</span>&#160; </div><div class="line"><a name="l00780"></a><span class="lineno">  780</span>&#160;}</div><div class="line"><a name="l00781"></a><span class="lineno">  781</span>&#160; </div><div class="line"><a name="l00782"></a><span class="lineno">  782</span>&#160;<span class="preprocessor">#endif // DLIB_SCAN_fHOG_PYRAMID_ABSTRACT_Hh_</span></div><div class="line"><a name="l00783"></a><span class="lineno">  783</span>&#160; </div><div class="line"><a name="l00784"></a><span class="lineno">  784</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1array_html"><div class="ttname"><a href="classdlib_1_1array.html">dlib::array</a></div><div class="ttdef"><b>Definition:</b> array_kernel.h:20</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
